import sys, csv, json
from twisted.internet import reactor
from autobahn.websocket import WebSocketServerFactory, WebSocketServerProtocol

class MeminfoServerProtocol(WebSocketServerProtocol):

  def onOpen(self):
    self.factory.meminfo(self)

class MeminfoServerFactory(WebSocketServerFactory):

  protocol = MeminfoServerProtocol

  def meminfo(self, client):
    reader = csv.reader(open('/proc/meminfo'), delimiter=':', skipinitialspace=True)
    dic=dict()
    for row in reader:
      dic[row[0]] = row[1]
    client.sendMessage(json.dumps(dic))
    reactor.callLater(5, self.meminfo, client)

if __name__ == '__main__':

  factory = MeminfoServerFactory()
  reactor.listenTCP(9000, factory)
  reactor.run()
